%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%define use_pylint 0

Name:           nitrate
Version:        3.3.4
Release:        2%{?dist}
Summary:        Test Case Management System

Group:          Development/Languages
License:        GPLv2+
URL:            https://fedorahosted.org/nitrate/
Source0:        https://fedorahosted.org/releases/n/i/nitrate/%{name}-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch
BuildRequires:  python-setuptools
BuildRequires:  python2-devel
%if %{use_pylint}
BuildRequires:  pylint
BuildRequires:  Django
%endif

Requires:       Django = 1.2.5
Requires:       mod_python
Requires:       mod_ssl
Requires:       python-memcached
Requires:       python-kerberos
Requires:       kobo-django >= 0.2.0-3
Requires:       mod_auth_kerb
Requires:       mod_wsgi
Requires:       w3m

%description
Nitrate is a tool for tracking testing being done on a product.

It is a database-backed web application, implemented using Django

%prep
%setup -q

# Fixup the version field in the page footer so that it shows the precise
# RPM version-release:
sed --in-place \
  -r 's|NITRATE_VERSION|%{version}|' \
  templates/tcms_base.html

%build
%{__python} setup.py build

%if %{use_pylint}
# Run pylint.  Halt the build if there are errors
# There doesn't seem to be a good way to get the result of pylint as an
# exit code.  (upstream bug: http://www.logilab.org/ticket/4691 )

# Capture the output:
pylint --rcfile=tcms/pylintrc tcms > pylint.log

# Ensure the pylint log makes it to the rpm build log:
cat pylint.log

# Analyse the "Messages by category" part of the report, looking for
# non-zero results:
# The table should look like this:
#   +-----------+-------+---------+-----------+
#   |type       |number |previous |difference |
#   +===========+=======+=========+===========+
#   |convention |0      |0        |=          |
#   +-----------+-------+---------+-----------+
#   |refactor   |0      |0        |=          |
#   +-----------+-------+---------+-----------+
#   |warning    |0      |0        |=          |
#   +-----------+-------+---------+-----------+
#   |error      |0      |0        |=          |
#   +-----------+-------+---------+-----------+
#   
# Halt the build if any are non-zero:
grep -E "^\|convention[ ]*\|0[ ]*\|" pylint.log || exit 1
grep -E "^\|refactor[ ]*\|0[ ]*\|" pylint.log || exit 1
grep -E "^\|warning[ ]*\|0[ ]*\|" pylint.log || exit 1
grep -E "^\|error[ ]*\|0[ ]*\|" pylint.log || exit 1
%endif


%install
rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT

# Copy static content from 32/64bit-specific python dir to shared data dir:
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/%{name}
mkdir -p ${RPM_BUILD_ROOT}%{_docdir}/%{name}

for d in contrib templates media; do
    cp -r ${d} ${RPM_BUILD_ROOT}%{_datadir}/%{name};
done

for f in `find tcms/core/lib -name templates`; do
    cp -r ${f}/* ${RPM_BUILD_ROOT}%{_datadir}/%{name}/templates/;
done

# Install apache config for the app:
install -m 0644 -D -p contrib/conf/nitrate-httpd.conf  ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf.d/%{name}.conf

 
%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc LICENSE COPYING docs/INSTALL docs/AUTHORS docs/ChangeLog docs/README docs/RELEASENOTES docs/UPGRADING docs/XMLRPC docs/testopia-dump-blank.sql docs/mysql_initial.sql
%{python_sitelib}/tcms/
%{python_sitelib}/Nitrate-%{version}-py*.egg-info/
%{_datadir}/%{name}
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf



%changelog
*Thu Jun 9 2011 Yuguang Wang <yuwang@redhat.com> - 3.3.4-2
- Change dependency package(django) from 1.2.3 to 1.2.5.
- Add denpendency package mod_python

*Fri Apr 14 2011 Yuguang Wang <yuwang@redhat.com> - 3.3.4-1
- Update changelog section in spec file.

*Fri Mar 3 2011 Yuguang Wang <yuwang@redhat.com> - 3.3-4
- Fixed an urgent issue while 'expand all' that may cause service error
- Fixed bz 681156 679677 672495

*Fri Feb 25 2011 Yuguang Wang <yuwang@redhat.com> - 3.3-3
- Remove 'running date' and add 'run date' in test case run details page.
- Fixed bz 680315 680321 627236 680322 680059 676259 678643 674754 676590

*Tue Feb 15 2011 Yuguang Wang <yuwang@redhat.com> - 3.3-2
- Some userablity improvements.
- Fixed bz 664025 658372 667304 654533 672873 664743 672857
- Fixed bz 657474 649293 643324 653815 658475 672622

*Mon Jan 24 2011 Yuguang Wang <yuwang@redhat.com> - 3.3-1
- Improved style of filtering test case runs page.
- Include apache QPID support
- Completed global signal processor
- Fixed case run percent counter
- Several bug fixes(see ChangeLog for details)

* Thu Dec 1 2010 Xuqing Kuang <xkuang@redhat.com> - 3.2-4
- Re-enabled assignee update notification.
- Some useability bug fixes: 658160 658495

* Tue Nov 30 2010 Xuqing Kuang <xkuang@redhat.com> - 3.2-3
- Remove the JSCal2 DateTime? widget(no longer in use).
- Added grappelli skin for tinyMCE
- Several bug fixes(see ChangeLog for details)

* Tue Nov 23 2010 Xuqing Kuang <xkuang@redhat.com> - 3.2-2
- Fixed own username/email in user profile display without register support
- Completed UI FEAT - Add case default tester in search plan
- Fixed username regex like Django restrictive
- Swap the first/last name in profile
- Fixed the run information style
- Several bug fixes(see ChangeLog for details)

* Tue Nov 9 2010 Xuqing Kuang <xkuang@redhat.com> - 3.2-1
- Makes nitrate Django 1.2 compatible
- Add csrf to templates/admin pages for Django 1.2
- Refined the js, split the case to confirmed cases and reviewing cases
- Completed basic info editing/viewing in profile
- Add the title/nav/footer to 404 & 500 error page
- Add NEED_UPDATE status to test case status
- Initial completed bookmark feature
- Completed reviewer for case and the mail notification when update reviewer
- Fixed new admin URL
- Lots of bug fixes, see ChangeLog.
- Merged the index page to profile
- Fixed default url redirect after login
- Initial completed the clone mulitple run from plan function
- Refine Home page
- Initial refined the mass status/priority operation function
- Fixed add bookmark without content_type issue
- Changed commit style, added order to comment
- Fixed redirect to review cases after case creation
- Refined the delete comment feature
- Fixed log display in details page
- Fixed auto case expanding in run page
- Fixed toolbar style on Chrome and safari
- Fixed update assignee feature
- Completed password change feature
- Removed the execute run link
- Completed registration feature
- Completed password reset feature
- Refined the update case run text and re-order case run feature
- Completed paginatation for case/run/plan list
- Linked the user linke to profile

* Fri Sep 17 2010 Xuqing Kuang <xkuang@redhat.com> - 3.1.1-3
- Fixed global plan search issue.

* Wed Sep 15 2010 Xuqing Kuang <xkuang@redhat.com> - 3.1.1-2
- Optimized the performance for pagination
- Several bug fixes(see ChangeLog for details)

* Wed Sep 8 2010 Xuqing Kuang <xkuang@redhat.com> - 3.1.1-1
- Improve the run report
- Fixed custom reporting search condition
- Added highcharts for future reporting
- Add pagination feature for TCMS test plans, test cases and test runs.
- Refined add plan to case feature
- Completed add multiple plan to a case feature
- Added parent modify feature to XML-RPC
- Several bug fixes(see ChangeLog for details)

* Thu Aug 12 2010 Xuqing Kuang <xkuang@redhat.com> - 3.1.0-2
- Enhanced the reporting feature.

* Thu Aug 12 2010 Xuqing Kuang <xkuang@redhat.com> - 3.1.0-1
- Completed new report with customization
- Fixed bz 612803 609777 618710 599313 619247 591823 618183 619403 599448 621777 598409

* Fri Aug 2 2010 Xuqing Kuang <xkuang@redhat.com> - 3.0.4-3
- Fixed #612797 - The Property in Environment can not be deleted
- Fixed #616463 - Remove property doesn't work in TCMS

* Fri Jul 30 2010 Xuqing Kuang <xkuang@redhat.com> - 3.0.4-2
- Fixed #619247 - Cannot update test case status

* Wed Jul 21 2010 Xuqing Kuang <xkuang@redhat.com> - 3.0.4-1
- First open sourced version.
- Added all of docs lacked for installation/upgrading/usage.
- Move the compoent of the case to be a tab
- Use the updateObject() function to reimplemented multiple operations.
- Several bug fixes(see ChangeLog for details)

* Mon Jun 28 2010 Xuqing Kuang <xkuang@redhat.com> - 3.0.3-2.svn2859
- Update the plan list & case list & run list
- Update the case run list
- Change from_config()'s return value from Nitrate to NitrateXmlrpc? 
- Completed edit environment in run page
- Use updateObject() function to modify the sortkey for caserun
- Fixed create case failed issue
- Completed feature #604860 - further improvement Add 'pk' for each item under …
- Fixed TestCase?.link_plan function returns
- Optimized front page display
- Several bug fixes(see ChangeLog for details)

* Sat Jun 12 2010 Xuqing Kuang <xkuang@redhat.com> - 3.0.3-1.svn2841
- Fixed remove case function in plan
- Fixed edit env property/value name to exist name caused 500 error
- Several bug fixes(see ChangeLog for details)

* Tue Jun 8 2010 Xuqing Kuang <xkuang@redhat.com> - 3.0.2-2.svn2819
- Fixed tags lacked after search issue.
- Optimized batch automated operation form
- Fixed some UI issues.
- Fixed bz 598935 598909 599465 593091

* Thu Jun 3 2010 Xuqing Kuang <xkuang@redhat.com> - 3.0.2-1.svn2805
- Use livepiple to replace scriptaculous and clean up the js codes.
- Added initial data for syncdb.
- Added unit test script.
- Merged testplans.views.cases and testcases.views.all
- Ability to mark test case as 'Manual', 'Automated' and 'Autopropsed'
- Fixed TestRun.update() XML-RPC docs.
- Several bug fixes(see ChangeLog for details)


* Wed May 19 2010 Xuqing Kuang <xkuang@redhat.com> - 3.0.1-3.svn2748
- Fixed bz 592212 543985 561234 577124 592974 592973
- Fixed report 500 service error
- Fixed get_components XML-RPC typo mistake and added docs to new filter …

* Thu May 13 2010 Xuqing Kuang <xkuang@redhat.com> - 3.0.1-2.svn2736
- Completed signal handler for mailing by a standalone threading
- Optimized the menu style
- Several bug fixes(see ChangeLog for details)

* Tue May 11 2010 Xuqing Kuang <xkuang@redhat.com> - 3.0.1-1.svn2728
- Refined whole UI.
- Optimized query count for performance.
- Add examples to XML-RPC docs.
- Completed following methods for XML-RPC: Product.filter(),
- Product.filter_categories(), Product.filter_components(), Product.filter_versions(),
- Product.get_component(), Product.get_tag(), Product.get_versions(),
- Product.lookup_id_by_name(), TestCase.calculate_average_estimated_time(),
- TestCase.calculate_total_estimated_time(), User.filter(), User.get(), User.update().
- Fixed UI bugs:  590647, 583908, 570351, 588970, 588565, 578828, 562110, 582958, 542664.
- Fixed app bugs: 582517, 582910, 584838, 586684, 584342, 578828, 577820, 583917, 562110,
- Fxied app bugs: 588595, 560791, 584459. 580494, 570351, 589124, 577130, 561406, 586085.

* Fri Apr 16 2010 Xuqing Kuang <xkuang@redhat.com> - 3.0-1b2.svn2665
- Fixed 582517 582910 574663
- Completed Ability to edit environment for existed test run
- Completed change case run assignee feature
- Completed get form ajax responder
- Optimized get info responder

* Wed Apr 14 2010 Xuqing Kuang <xkuang@redhat.com> - 3.0-1b1.svn2650
- Initial completed most new features, extend database schema
- Initial completed bookmark(watch list) feature(Models added)
- Initial completed modify run environment value feature(Backend code)
- Extend the schema for outside bug track system(Backend code)
- Improve run mail feature
- Optimized XML-RPC and the docs
- Fixed 'Save and add another' crash when create new case
- Fixed Assign case to run and create new run without default tester.
- Fixed Build.create() bug
- Fixed TestRun.get_test_case_runs() bug

* Thu Apr 1 2010 Xuqing Kuang <xkuang@redhat.com> - 2.3-5.svn2599
- Fixed add tag to run cause to crash issue.

* Mon Mar 29 2010 Xuqing Kuang <xkuang@redhat.com> - 2.3-4.svn2594
- Completed create/update functions for XML-RPC.
- Fixed web browser compatible issues.
- Improve review case progress.

* Tue Mar 23 2010 Xuqing Kuang <xkuang@redhat.com> - 2.3-3.svn2577
- Fixed Webkit based browser compatible issues
- Fixed TinyMCE in Webkit based browser compatible issues
- Fixed UI Bug: #570351, #553308

* Mon Mar 22 2010 Xuqing Kuang <xkuang@redhat.com> - 2.3-2.svn2568
- Fixed search case without product issue(r2567)
- Fixed create run foot UI issue(r2566)
- Fixed update component in search case issue(r2565)

* Thu Mar 18 2010 Xuqing Kuang <xkuang@redhat.com> - 2.3-1.svn2564
- Complete most of XML-RPC functions.
- Complete batch operation for case including setting priority, add/remove tag.
- Fixed most of bugs.

* Wed Mar 17 2010 Xuqing Kuang <xkuang@redhat.com> -2.2-4.svn2504
- Fixed version in web ui incorrect.

* Fri Mar 12 2010 Xuqing Kuang <xkuang@redhat.com> - 2.2-3.svn2504
- HOT BUG FIXING - #572487

* Thu Mar 4 2010 Xuqing Kuang <xkuang@redhat.com> - 2.2-2.svn2504
- Fixed UI bug: Execute link exceed the width issue
- Fixed UI bug: CC for run page display issue

* Mon Mar 1 2010 Xuqing Kuang <xkuang@redhat.com> - 2.2-1.svn2500
- Add a new serializer for XMLRPC serialization
- Fixed KerbTransport authorization issue
- Change deployment method to WSGI
- A lot of bugs fixing for application.
- Fixed a lot of UI bugs

* Thu Feb 11 2010 Xuqing Kuang <xkuang@redhat.com> - 2.1-4.svn2461
- Fixed application bug #561620
- Fixed bz 529807 561610 552923 561252 553308 558955 560091 560055

* Tue Feb 2 2010 Xuqing Kuang <xkuang@redhat.com> - 2.1-3.svn2449
- Remove product version from case search page.
- Optimize search case form.

* Tue Feb 2 2010 Xuqing Kuang <xkuang@redhat.com> - 2.1-2.svn2446
- Fixed the case display with the bug added directly in case page in run issue.
- Fixed edit case component selector issue.
- Case product link to category now, disconnect from plan.

* Mon Feb 1 2010 Xuqing Kuang <xkuang@redhat.com> - 2.1-1.svn2443
- Rewrite get case details to ajax code, for optimize performance
- Add tag support for test run
- Add bug to case directly now supported.

* Mon Jan 18 2010 Xuqing Kuang <xkuang@redhat.com> - 2.0-3.svn2403
- Fixed hot issue #556382

* Mon Jan 18 2010 Xuqing Kuang <xkuang@redhat.com> - 2.0-2.svn2402
- Fixed auto blind down issue
- Completed add tag to case/plan when create backend function
- Fixed 555702 555703 555707 554676

* Fri Jan 15 2010 Xuqing Kuang <xkuang@redhat.com> - 2.0-1.svn2394
- Fixed most of bugs
- The component will add to new product specific in clone function
- Use Cache backend to handle session
- More optimization

* Mon Jan 11 2010 Xuqing Kuang <xkuang@redhat.com> - 2.0-1RC.svn2368
- Fixed a lot of bugs
- Optimize new comment system
- Completed new log system
- Add new case fiter to plan
- Improve new review workflow
- Update setup.py

* Tue Dec 29 2009 Xuqing Kuang <xkuang@redhat.com> - 2.0-1beta.svn2318
- First public beta release of 2.0
- Rewrite most components
- Add estimated time into run
- Add test case review workflow
- Add XML-RPC interface
- Use a lot Ajax to instead of render whole page
- Redesign the interface

* Fri Dec 18 2009 Xuqing Kuang <xkuang@redhat.com> - 1.3-3.svn2261
- Add case run changelog show in run details page feature

* Tue Dec 8 2009 Xuqing Kuang <xkuang@redhat.com> - 1.3-2.svn2229
- Fixed reporing when plan count is null issue
- Update overview report of product statistics SQL
- Fixed 544951 544229 543985 544951

* Fri Dec 4 2009 Xuqing Kuang <xkuang@redhat.com> - 1.3-1.svn2213
- Optimize delete case/run ACL policy.
- Initial completed Reporting feature.
- Initial XML-RPC interface
- Fixed bz 541823 541829

* Wed Nov 25 2009 Xuqing Kuang <xkuang@redhat.com> - 1.2-3.svn2167
- Made a mistake in checkout the source, so rebuild it.

* Wed Nov 25 2009 Xuqing Kuang <xkuang@redhat.com> - 1.2-2.svn2167
- Use QuerySet update function to batch modify the database
- Restore search detect in plan all page
- Fixed bug 530478 538747 540794 538849 540371

* Fri Nov 20 2009 Xuqing Kuang <xkuang@redhat.com> - 1.2-1.svn2143
- Fixed bz 530010 531942 536996 533866 536982 533869
- Optimize a lot of UI and frontend permission control
- Remove manage case page
- Enhanced sort case feature with drag and drop in plan and run
- Completed change multiple case status at one time
- Completed change run status feature
- Completed clone multiple plan feature
- Completed upload plan document with ODT format
- Completed case attachment feature

* Mon Nov 9 2009 Xuqing Kuang <xkuang@redhat.com> - 1.1-1.svn2097
- Release 1.1 version TCMS
- Completed clone case/run feature
- Refined the UI structure
- Add XML-RPC interface for ATP

* Mon Nov 9 2009 Xuqing Kuang <xkuang@redhat.com> - 1.0-9.svn2046
- Add mod_auth_kerb.patch for authorize with apache kerberos module.

* Thu Oct 22 2009 Xuqing Kuang <xkuang@redhat.com> - 1.0-7.svn2046.RC
- Improve templates

* Thu Oct 22 2009 Xuqing Kuang <xkuang@redhat.com> - 1.0-6.svn2046.RC
- Imporove test plan clone feature
- Fixed failed case run count in run details page
- Add RELEASENOTES

* Wed Oct 21 2009 Xuqing Kuang <xkuang@redhat.com> - 1.0-5.svn2042.RC
- Realign the version to 1.0
- Fixed most of bugs

* Wed Oct 16 2009 Xuqing Kuang <xkuang@redhat.com> - 2.0-4.svn2006.RC
- Fixed other unimportant bugs, release RC.

* Wed Oct 14 2009 Xuqing Kuang <xkuang@redhat.com> - 2.0-3.svn1971
- Fixed most of bugs and get ready to GA.
- KNOWN ISSUE: Search case to add to plan just complete the page design, is waiting for logic function.

* Wed Sep 30 2009 Xuqing Kuang <xkuang@redhat.com> - 2.0-2.svn1938
- Rewrite assign case page
- Rewrite attachment implementation
- Search with environment is available
- Fixed app bugs: 524578 524568 524534 
- Fixed UI Bugs: 524530 525044 524568 524140 525614 524777 525630 525830 525606 

* Tue Sep 23 2009 Xuqing Kuang <xkuang@redhat.com> - 2.0-2.svn1898
- Completed environment element modfiy/delete feature in admin
- Fixed bz 525039 521327 524230 524536 524530 518652 524774 525044 524778

* Tue Sep 15 2009 Xuqing Kuang <xkuang@redhat.com> - 2.0-1.svn1863
- Remove case from plan
- Sort case in plan
- Fixed edit case issue

* Tue Sep 1 2009 Xuqing Kuang <xkuang@redhat.com> - 2.0-1.svn1833
- Fixed a lot of bug.
- Redesign the interface.

* Wed Jul 22 2009 Xuqing Kuang <xkuang@redhat.com> - 2.0-1.svn1799
- Rewrite most of components
- Add tables from Django
- dump version to 2.0 (trunk development version)

* Thu Mar 19 2009 David Malcolm <dmalcolm@redhat.com> - 0.16-6.svn1547
- require kerberos authentication

* Tue Mar 17 2009 David Malcolm <dmalcolm@redhat.com> - 0.16-5.svn1525
- mark tcms/product_settings.py as being a config file
- add dependency on mod_ssl

* Tue Mar 17 2009 David Malcolm <dmalcolm@redhat.com> - 0.16-4.svn1525
- substitute RPM metadata into the page footer so that it always shows the exact revision of the code
- bump to svn revision 1525

* Thu Mar 12 2009 David Malcolm <dmalcolm@redhat.com> - 0.16-3.svn1487
- drop the dist tag

* Thu Mar 12 2009 David Malcolm <dmalcolm@redhat.com> - 0.16-2.svn1487
- add build-requires on Django to try to get pylint to work (otherwise: tcms/urls.py:11: [E0602] Undefined variable 'patterns')

* Thu Mar 12 2009 David Malcolm <dmalcolm@redhat.com> - 0.16-1.svn1487
- 0.16
- add build-requires on python-setuptools

* Tue Feb 24 2009 David Malcolm <dmalcolm@redhat.com> - 0.13-4
- fix regexp for pylint errors

* Tue Feb 24 2009 David Malcolm <dmalcolm@redhat.com> - 0.13-3
- add code to invoke pylint.  Stop building the rpm if pylint finds a problem.

* Wed Feb 18 2009 David Malcolm <dmalcolm@redhat.com> - 0.13-2.svn1309
- add mod_python and python-memcached dependencies
- move static content to below datadir
- add apache config to correct location

* Thu Feb 12 2009 David Malcolm <dmalcolm@redhat.com> - 0.13-1.svn1294
- initial packaging
